Index: cprs/trunk/CPRS-Chart/fGraphs.pas
===================================================================
--- cprs/trunk/CPRS-Chart/fGraphs.pas	(revision 456)
+++ cprs/trunk/CPRS-Chart/fGraphs.pas	(revision 830)
@@ -5438,232 +6258,4 @@
       end;
     end;
-    GetHorizAxis.ExactDateTime := True;
-    GetHorizAxis.Increment := DateTimeStep[dtOneMinute];
-  end;
-end;
-
-procedure TfrmGraphs.MakeWeightedGanttSeries(aChart: TChart; aTitle, aFileType: string; var aSerCnt: integer);
-var
-  i: integer;
-  value: double;
-  fmtime, fmtime1: string;
-  gantt: TGanttSeries;
-  adatetime, adatetime1: TDateTime;
-begin
-  aSerCnt := aSerCnt + 1;
-  gantt := TGanttSeries.Create(aChart);
-  with gantt do
-  begin
-    ParentChart := aChart;
-    Title := Piece(aTitle, '^', 3);
-    Marks.Style := smsLabel;
-    OnGetMarkText := serDatelineTop.OnGetMarkText;
-    value := NUM_COLORS;
-    GetData(aTitle);
-    ColorEachPoint := false;
-    SeriesColor := NextColor(aSerCnt);
-    Identifier := aFileType;
-    Marks.BackColor := clInfoBk;
-    with lstTemp do
-    for i:= 0 to Items.Count - 1 do
-    begin
-      fmtime := FMCorrectedDate(Piece(Items[i], '^', 3));
-      fmtime1 := FMCorrectedDate(Piece(Items[i], '^', 4));
-      if IsFMDateTime(fmtime) and IsFMDateTime(fmtime1) then
-      begin
-        HighLow(fmtime, fmtime1, aChart, adatetime, adatetime1);
-        value := Vfactor(Piece(aTitle, '^', 3));
-        AddGantt(adatetime, adatetime1, 1, '');
-        value := value + (value / 2);
-      end;
-    end;
-    Pointer.VertSize := round(value);
-    GetHorizAxis.ExactDateTime := True;
-    GetHorizAxis.Increment := DateTimeStep[dtOneMinute];
-  end;
-end;
-
-procedure TfrmGraphs.MakeArrowSeries(aChart: TChart; aTitle, aFileType: string; var aSerCnt: integer);
-var
-  i: integer;
-  value: double;
-  fmtime, fmtime1: string;
-  arrows: TArrowSeries;
-  adatetime, adatetime1: TDateTime;
-begin
-  aSerCnt := aSerCnt + 1;
-  arrows := TArrowSeries.Create(aChart);
-  with arrows do
-  begin
-    ParentChart := aChart;
-    Title := Piece(aTitle, '^', 3);
-    Clear;
-    ArrowWidth := 12;
-    ArrowHeight := 9;
-    StartXValues.DateTime := true;
-    EndXValues.DateTime := true;
-    Marks.Style := smsLabel;
-    OnGetMarkText := serDatelineTop.OnGetMarkText;
-    Pointer.Visible := false;
-    Pointer.VertSize := 17; //pnlTop.Height;        //******* for meds
-    Pointer.HorizSize := 24;
-    Pointer.InflateMargins := true;
-    GetData(aTitle);
-    ColorEachPoint := false;
-    SeriesColor := NextColor(aSerCnt);
-    Identifier := aFileType;
-    Marks.BackColor := clInfoBk;
-    with lstTemp do
-    for i:= 0 to Items.Count - 1 do
-    begin
-      fmtime := FMCorrectedDate(Piece(Items[i], '^', 3));
-      fmtime1 := FMCorrectedDate(Piece(Items[i], '^', 4));
-      if IsFMDateTime(fmtime) and IsFMDateTime(fmtime1) then
-      begin
-        HighLow(fmtime, fmtime1, aChart, adatetime, adatetime1);
-        value := strtofloatdef(Piece(Items[i], '^', 5), -BIG_NUMBER);
-        if value = -BIG_NUMBER then
-          TempCheck(Pieces(Items[i], '^', 1, 2), value);
-        AddArrow(adatetime, value, adatetime1, value, '', SeriesColor);
-      end;
-    end;
-    GetHorizAxis.ExactDateTime := True;
-    GetHorizAxis.Increment := DateTimeStep[dtOneMinute];
-  end;
-end;
-
-procedure TfrmGraphs.MakeWeightedArrowSeries(aChart: TChart; aTitle, aFileType: string; var aSerCnt: integer);
-var
-  i: integer;
-  value: double;
-  fmtime, fmtime1: string;
-  adatetime, adatetime1: TDateTime;
-  arrows: TArrowSeries;
-begin
-  aSerCnt := aSerCnt + 1;
-  arrows := TArrowSeries.Create(aChart);
-  with arrows do
-  begin
-    ParentChart := aChart;
-    Title := Piece(aTitle, '^', 3);
-    Clear;
-    ArrowWidth := 12;
-    ArrowHeight := 9;
-    StartXValues.DateTime := true;
-    EndXValues.DateTime := true;
-    Marks.Style := smsLabel;
-    OnGetMarkText := serDatelineTop.OnGetMarkText;
-    Pointer.Visible := false;
-    Pointer.VertSize := 17; //pnlTop.Height;        //******* for meds
-    Pointer.HorizSize := 24;
-    Pointer.InflateMargins := true;
-    GetData(aTitle);
-    ColorEachPoint := false;
-    SeriesColor := NextColor(aSerCnt);
-    Identifier := aFileType;
-    Marks.BackColor := clInfoBk;
-    with lstTemp do
-    for i:= 0 to Items.Count - 1 do
-    begin
-      fmtime := FMCorrectedDate(Piece(Items[i], '^', 3));
-      fmtime1 := FMCorrectedDate(Piece(Items[i], '^', 4));
-      if IsFMDateTime(fmtime) and IsFMDateTime(fmtime1) then
-      begin
-        HighLow(fmtime, fmtime1, aChart, adatetime, adatetime1);
-        value := strtofloatdef(Piece(Items[i], '^', 5), -BIG_NUMBER);
-        if value = -BIG_NUMBER then
-          TempCheck(Pieces(Items[i], '^', 1, 2), value);
-        AddArrow(adatetime, value, adatetime1, value, '', SeriesColor);
-      end;
-    end;
-    value := Vfactor(Piece(aTitle, '^', 3));
-    if value < 1 then value := 1;
-    Pointer.HorizSize := round(value);
-    GetHorizAxis.ExactDateTime := True;
-    GetHorizAxis.Increment := DateTimeStep[dtOneMinute];
-  end;
-end;
-
-procedure TfrmGraphs.MakeGanttSeries(aChart: TChart; aTitle, aFileType: string; var aSerCnt: integer);
-var
-  i: integer;
-  value: double;
-  fmtime, fmtime1: string;
-  adatetime, adatetime1: TDateTime;
-  gantt: TGanttSeries;
-begin
-  aSerCnt := aSerCnt + 1;
-  gantt := TGanttSeries.Create(aChart);
-  with gantt do
-  begin
-    ParentChart := aChart;
-    Title := Piece(aTitle, '^', 3);
-    Marks.Style := smsLabel;
-    OnGetMarkText := serDatelineTop.OnGetMarkText;
-    Pointer.VertSize := pnlTop.Height;        //******* like vertical bars
-    GetData(aTitle);
-    ColorEachPoint := false;
-    SeriesColor := NextColor(aSerCnt);
-    Identifier := aFileType;
-    Marks.BackColor := clInfoBk;
-    with lstTemp do
-    for i:= 0 to Items.Count - 1 do
-    begin
-      fmtime := FMCorrectedDate(Piece(Items[i], '^', 3));
-      fmtime1 := FMCorrectedDate(Piece(Items[i], '^', 4));
-      if IsFMDateTime(fmtime) and IsFMDateTime(fmtime1) then
-      begin
-        HighLow(fmtime, fmtime1, aChart, adatetime, adatetime1);
-        value := strtofloatdef(Piece(Items[i], '^', 5), -BIG_NUMBER);
-        if value = -BIG_NUMBER then
-          TempCheck(Pieces(Items[i], '^', 1, 2), value);
-        AddGantt(adatetime, adatetime1, 1, '');
-      end;
-    end;
-    GetHorizAxis.ExactDateTime := True;
-    GetHorizAxis.Increment := DateTimeStep[dtOneMinute];
-  end;
-end;
-
-procedure TfrmGraphs.MakeAGanttSeries(aChart: TChart; aTitle, aFileType: string; var aSerCnt: integer);
-var
-  i: integer;
-  value: double;
-  fmtime, fmtime1: string;
-  gantt: TGanttSeries;
-  adatetime, adatetime1: TDateTime;
-begin
-  aSerCnt := aSerCnt + 1;
-  if aChart = chartDatelineTop then
-    gantt := serDatelineTop
-  else
-    gantt := serDatelineBottom;
-  with gantt do
-  begin
-    ParentChart := aChart;
-    Active := true;
-    Title := Piece(aTitle, '^', 3);
-    Marks.Style := smsLabel;
-    OnGetMarkText := serDatelineTop.OnGetMarkText;
-    //Pointer.VertSize := pnlTop.Height;        //******* for meds
-    GetData(aTitle);
-    Identifier := aFileType;
-    ColorEachPoint := True;
-    with lstTemp do
-    for i:= 0 to Items.Count - 1 do
-    begin
-      fmtime := FMCorrectedDate(Piece(Items[i], '^', 3));
-      fmtime1 := FMCorrectedDate(Piece(Items[i], '^', 4));
-      if IsFMDateTime(fmtime) and IsFMDateTime(fmtime1) then
-      begin
-        HighLow(fmtime, fmtime1, aChart, adatetime, adatetime1);
-        value := strtofloatdef(Piece(Items[i], '^', 5), -BIG_NUMBER);
-        if value = -BIG_NUMBER then
-          TempCheck(Pieces(Items[i], '^', 1, 2), value);
-        AddGantt(adatetime, adatetime1, aSerCnt, '');
-      end;
-    end;
-    GetHorizAxis.ExactDateTime := True;
-    GetHorizAxis.Increment := DateTimeStep[dtOneMinute];
   end;
 end;
@@ -5675,44 +6267,77 @@
 end;
 
-function TfrmGraphs.ValueText(Sender: TCustomChart; Series: TChartSeries; ValueIndex: Integer): string;
+function TfrmGraphs.NonNumText(listnum , seriesnum, valueindex: integer): string;
+var
+  ok: boolean;
+  i: integer;
+  nonvalue, date1, resultdate, otherdate: string;
+  datestart: double;
+  charttag, filename, typeitemname, filenum, itemnum, specimen, seriescheck, value: string;
+begin
+  ok := false;
+  seriescheck := inttostr(seriesnum - BIG_NUMBER);
+  charttag := inttostr(listnum);
+  for i := 0 to GtslNonNum.Count - 1 do
+  begin
+    nonvalue := GtslNonNum[i];
+    if Piece(nonvalue, '^', 2) = charttag then
+      if Piece(nonvalue, '^', 3) = seriescheck then
+        if Piece(nonvalue, '^', 4) = inttostr(valueindex + 1) then
+      begin
+        ok := true;
+        break;
+      end;
+  end;
+  if not ok then
+  begin
+    Result := '';
+    exit;
+  end;
+  date1    := Piece(nonvalue, '^', 1);
+  filenum  := Piece(nonvalue, '^', 9);
+  itemnum  := Piece(nonvalue, '^', 10);
+  value    := Piece(nonvalue, '^', 13);
+  specimen := Piece(nonvalue, '^', 16);
+  filename := FileNameX(filenum);
+  typeitemname := MixedCase(ItemName(filenum, itemnum));
+  if length(specimen) > 0 then
+    typeitemname := typeitemname + ' (' + LowerCase(specimen) + ')';
+  datestart := strtofloat(date1);
+  resultdate := FormatDateTime('mmm d, yyyy  h:nn am/pm', datestart);
+  otherdate := FormatDateTime('mm/dd/yy hh:nn', datestart);
+  Result := filenum + '^' +filename + '^' + resultdate + '^'
+          + typeitemname + '^' + value + '^' + otherdate;
+end;
+
+function TfrmGraphs.ValueText(Sender: TCustomChart; aSeries: TChartSeries; ValueIndex: Integer): string;
 var      // type#^typename^formatdate^itemname^result^date
-  i, offset, SeriesNum, selnum: integer;
-  dateend, datestart: double;
-  astring, datecheck, filetype, fmdatecheck, item, otherdate, partitem: string;
-  resultdate, results, seriestitle, typeitem, typename, typenum: string;
-begin
+  OKToUse: boolean;
+  i, SeriesNum, selnum, chartnum: integer;
+  filetype, otherdate: string;
+  resultdate, resultstring, seriestitle, typeitem, typename, typenum: string;
+begin
+  Result := '';
   SeriesNum := -1;
-  for i := 0 to Sender.SeriesCount -1 do
-  if Sender.Series[i] = Series then
-  begin
-    SeriesNum := i;
-    filetype := Sender.Series[i].Identifier;
-    break;
-  end;
-  seriestitle := Sender.Series[SeriesNum].Title;
-  if (seriestitle = '') and (SeriesNum < (Series.Count - 1)) then
-    if Sender.Series[SeriesNum + 1].Title = '(non-numeric)' then
-    begin
-      SeriesNum := SeriesNum + 1;
-      seriestitle := '(non-numeric)';
-    end;
-  Result := '';
-  if seriestitle <> '(non-numeric)' then
-  begin
-    ItemCheck(lvwItemsTop, seriestitle, selnum, typeitem);
-    typeitem := UpperCase(typeitem);
-  end
-  else
-  begin
-    selnum := 1;
-    typeitem := '63';
-    offset := 2; // 2 series before
-    if (copy(Sender.Series[SeriesNum - offset].Title, 1, 4) = 'Ref ') then
-      if SeriesNum - 4 > -1 then
-        offset := 4 // if ref ranges
-      else if SeriesNum - 3 > -1 then
-        offset := 3; // if ref ranges
-    seriestitle := Sender.Series[SeriesNum - offset].Title + ' ' + seriestitle;
-  end;
+  for i := 0 to Sender.SeriesCount - 1 do
+    if Sender.Series[i] = aSeries then
+    begin
+      SeriesNum := i;
+      filetype := Sender.Series[i].Identifier;
+      break;
+    end;
+  if SeriesNum = -1 then
+  begin
+    Result := '';
+    exit;
+  end;
+  chartnum := Sender.Tag;
+  seriestitle := Piece(Sender.Series[SeriesNum].Title, '^', 1);
+  if seriestitle = '(non-numeric)' then
+  begin
+    Result := NonNumText(chartnum, (aSeries as TChartSeries).Tag, ValueIndex);
+    exit;
+  end;
+  ItemCheck(lvwItemsTop, seriestitle, selnum, typeitem);
+  typeitem := UpperCase(typeitem);
   if selnum < 0 then
   begin
@@ -5726,28 +6351,5 @@
     typeitem := typenum + '^' + Piece(typeitem, '^', 2);
   end;
-  if typenum = '55' then
-  begin
-    if Series is TGanttSeries then
-      if (Series as TGanttSeries).Pointer.VertSize <> RX_HEIGHT_IN then
-      if (Series as TGanttSeries).Pointer.VertSize <> RX_HEIGHT_NVA then
-        typenum := '52'
-      else typenum := '55NVA';
-  end
-  else if typenum = '55NVA' then
-  begin
-    if Series is TGanttSeries then
-      if (Series as TGanttSeries).Pointer.VertSize <> RX_HEIGHT_NVA then
-      if (Series as TGanttSeries).Pointer.VertSize <> RX_HEIGHT_OUT then
-        typenum := '55'
-      else typenum := '52';
-  end
-  else if typenum = '52' then
-  begin
-    if Series is TGanttSeries then
-      if (Series as TGanttSeries).Pointer.VertSize <> RX_HEIGHT_OUT then
-      if (Series as TGanttSeries).Pointer.VertSize <> RX_HEIGHT_NVA then
-        typenum := '55'
-      else typenum := '55NVA';
-  end;
+  CheckMedNum(typenum, aSeries);
   typename := FileNameX(typenum);
   if ValueIndex < 0 then
@@ -5760,12 +6362,25 @@
   else if Copy(typename, length(typename), 1) = 's' then
     typename := Copy(typename, 1, length(typename) - 1);
-  if (Series is TGanttSeries) then
-  begin
-    datestart := (Series as TGanttSeries).StartValues[ValueIndex];
-    dateend := (Series as TGanttSeries).EndValues[ValueIndex];
+  ValueDates(aSeries, ValueIndex, resultdate, otherdate);
+  ResultValue(resultstring, seriestitle, typenum, typeitem, Sender, aSeries, ValueIndex, SeriesNum, OKToUse);
+  if not OKToUse then
+    Result := ''
+  else
+    Result := typenum + '  ^' + typename + '^' + resultdate + '^' +
+      seriestitle + '^' + resultstring + '^' + otherdate;
+end;
+
+procedure TfrmGraphs.ValueDates(aSeries: TChartSeries; ValueIndex: Integer; var resultdate, otherdate: string);
+var
+  dateend, datestart: double;
+begin
+  if (aSeries is TGanttSeries) then
+  begin
+    datestart := (aSeries as TGanttSeries).StartValues[ValueIndex];
+    dateend := (aSeries as TGanttSeries).EndValues[ValueIndex];
   end
   else
   begin
-    datestart := Series.XValue[ValueIndex];
+    datestart := aSeries.XValue[ValueIndex];
     dateend := datestart;
   end;
@@ -5782,20 +6397,63 @@
     otherdate := FormatDateTime('mm/dd/yy hh:nn', datestart);
   end;
-  results := '';
+end;
+
+procedure TfrmGraphs.CheckMedNum(var typenum: string; aSeries: TChartSeries);
+begin
+  if typenum = '55' then
+  begin
+    if aSeries is TGanttSeries then
+    if (aSeries as TGanttSeries).Pointer.VertSize <> RX_HEIGHT_IN then
+    if (aSeries as TGanttSeries).Pointer.VertSize <> RX_HEIGHT_NVA then
+      typenum := '52'
+    else typenum := '55NVA';
+  end
+  else if typenum = '55NVA' then
+  begin
+    if aSeries is TGanttSeries then
+    if (aSeries as TGanttSeries).Pointer.VertSize <> RX_HEIGHT_NVA then
+    if (aSeries as TGanttSeries).Pointer.VertSize <> RX_HEIGHT_OUT then
+      typenum := '55'
+    else typenum := '52';
+  end
+  else if typenum = '52' then
+  begin
+    if aSeries is TGanttSeries then
+    if (aSeries as TGanttSeries).Pointer.VertSize <> RX_HEIGHT_OUT then
+    if (aSeries as TGanttSeries).Pointer.VertSize <> RX_HEIGHT_NVA then
+      typenum := '55'
+    else typenum := '55NVA';
+  end;
+end;
+
+procedure TfrmGraphs.ResultValue(var resultstring, seriestitle: string; typenum, typeitem: string;
+  Sender: TCustomChart; aSeries: TChartSeries; ValueIndex, SeriesNum: Integer; var OKToUse: boolean);
+var
+  i: integer;
+  item, partitem, fmdatecheck, astring, datecheck: string;
+begin
+  resultstring := '';
+  OKToUse := true;
   if typenum = '63' then
   begin
-    if Series is TLineSeries then
-      if (Series as TLineSeries).LinePen.Style = psDash then
-        exit;          // serHigh or serLow
-    if Series is TPointSeries then
-      if (Series as TPointSeries).Pointer.Style = psSmallDot then
-        exit;         // serBlank
+    if aSeries is TLineSeries then
+      if (aSeries as TLineSeries).LinePen.Style = psDash then
+      begin
+        OKToUse := false;
+        exit;    // serHigh or serLow
+      end;
+    if aSeries is TPointSeries then
+      if (aSeries as TPointSeries).Pointer.Style = psSmallDot then
+      begin
+        OKToUse := false;
+        exit;    // serBlank
+      end;
     if copy(seriestitle, length(seriestitle) - 12, length(seriestitle)) = '(non-numeric)' then
     begin
       seriestitle := copy(seriestitle, 1, length(seriestitle) - 13);
-      serDatelineTopGetMarkText(Sender.Series[SeriesNum], ValueIndex, results);
+      serDatelineTopGetMarkText(Sender.Series[SeriesNum], ValueIndex, resultstring);
     end
     else
-      results := floattostr(Series.YValue[ValueIndex]);
+      resultstring := floattostr(aSeries.YValue[ValueIndex]);
   end
   else if typenum <> '120.5' then
@@ -5805,8 +6463,8 @@
     //if (partitem = 'M;A;') then     //or (partitem = 'M;T;') then   tb antibiotic on 1st piece
     begin
-      fmdatecheck := floattostr(DateTimeToFMDateTime(Series.XValue[ValueIndex]));
-      for i := 0 to lstData.Items.Count - 1 do
+      fmdatecheck := floattostr(DateTimeToFMDateTime(aSeries.XValue[ValueIndex]));
+      for i := 0 to GtslData.Count - 1 do
       begin
-        astring := lstData.Items[i];
+        astring := GtslData[i];
         if item = Piece(astring, '^', 2) then
         begin
@@ -5816,5 +6474,5 @@
           if datecheck = fmdatecheck then
           begin
-            results := MixedCase(Piece(astring, '^', 5));
+            resultstring := MixedCase(Pieces(astring, '^', 5, 6)) + '^' + Piece(astring, '^', 7);
             break;
           end;
@@ -5826,15 +6484,13 @@
   begin
     if seriestitle = 'Blood Pressure' then
-      results := BPValue(Series.XValue[ValueIndex])
+      resultstring := BPValue(aSeries.XValue[ValueIndex])
     else
-      results := floattostr(Series.YValue[ValueIndex]);
-  end;
-  Result := typenum + '  ^' + typename + '^' + resultdate + '^' +
-    seriestitle + '^' + results + '^' + otherdate;
+      resultstring := floattostr(aSeries.YValue[ValueIndex]);
+  end;
 end;
 
 procedure TfrmGraphs.chartBaseMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
 var
-  ClickedLegend, ClickedValue, j: Integer;
+  ClickedLegend, ClickedMark, ClickedValue, j: Integer;
   itemname: string;
   NewPt: TPoint;
@@ -5845,6 +6501,7 @@
   FActiveGraph := (Sender as TChart);
   NewPt := Mouse.CursorPos;
-  ClickedValue := -1;
   ClickedLegend := -1;
+  ClickedMark   := -1;
+  ClickedValue  := -1;
   if FHintWinActive then exit;
   with FActiveGraph do
@@ -5858,9 +6515,11 @@
         ClickedValue := Clicked(FX, FY);
         if ClickedValue > -1 then break;
+        ClickedMark := Marks.Clicked(FX, FY);
+        if ClickedMark > -1 then break;
         ClickedLegend := Legend.Clicked(FX, FY);
         if ClickedLegend > -1 then break;
       end;
     end;
-    if ClickedValue > -1 then
+    if (ClickedValue > -1) or (ClickedMark > -1) then
     begin
       FHintStop := false;
@@ -5883,8 +6542,67 @@
 end;
 
+procedure TfrmGraphs.chartBaseMouseUp(Sender: TObject; Button: TMouseButton;
+  Shift: TShiftState; X, Y: Integer);
+begin
+  (Sender as TChart).AllowZoom := FGraphSetting.HorizontalZoom;      // avoids cursor rectangle from appearing
+end;
+
+procedure TfrmGraphs.FormatHint(var astring: string);
+var
+  i, j: integer;
+  titlename, dttm, itemname, info, slice, text, value, newinfo, hintslice, hintformat: string;
+begin
+  // hint format: slice|slice|slice| ...
+  // where | is linebreak and slice is [text] value~[text] value~[text] value~ ...
+  hintformat := Piece(TypeString(Piece(Piece(astring, '^', 1), ' ', 1)), '^', 9);
+  titlename := Piece(astring, '^', 2);
+  dttm := Piece(astring, '^', 3);
+  if copy(astring, length(astring) - 5, length(astring)) = ' 00:00' then
+    dttm := Pieces(dttm, ' ', 1, 3);
+  itemname := Piece(astring, '^', 4);
+  info := itemname + '~' + Piece(astring, '^', 5) + '~';
+  newinfo := '';
+  for i := 1 to BIG_NUMBER do
+  begin
+    hintslice := Piece(hintformat, '|', i);
+    slice := Piece(info, '|', i);
+    for j := 1 to BIG_NUMBER do
+    begin
+      text := Piece(hintslice, '~', j);
+      value := Piece(info, '~', j);
+      newinfo := newinfo + text + ' ' + value;
+      //if Piece(hintslice, '~', j + 1) = '' then
+      //  break;                                                   .
+
+      if Pos('~', hintslice) = length(hintslice) then
+        break;
+      if Piece(slice, '~', j + 1) = '' then
+        break;
+    end;
+    if Piece(hintslice, '|', i + 1) = '' then
+      break;
+    if length(Piece(hintformat, '|', i + 1)) > 0 then
+      newinfo := newinfo + #13;
+    if Piece(hintformat, '|', i + 1) = '' then
+      break;
+  end;
+  astring := titlename + '  ' + dttm + #13 + newinfo; //itemname + '  ' + newinfo;
+end;
+
 procedure TfrmGraphs.timHintPauseTimer(Sender: TObject);
+
+  function TitleOK(aTitle: string): boolean;
+  begin
+    Result := false;
+    if Copy(aTitle, 1, 7)= 'Ref Low' then exit
+    else if Copy(aTitle, 1, 8)= 'Ref High' then exit
+    else if aTitle = TXT_COMMENTS then exit
+    else if aTitle = TXT_NONNUMERICS then exit;
+    Result := true;
+  end;
+
 var
   ClickedValue, j: Integer;
-  dttm, itemname, textvalue: string;
+  textvalue: string;
   Rct: TRect;
 begin
@@ -5897,4 +6615,5 @@
       if FHintStop then break;
       ClickedValue := Clicked(FX, FY);
+      if ClickedValue = -1 then ClickedValue := Marks.Clicked(FX, FY);
       if ClickedValue > -1 then break;
     end;
@@ -5910,15 +6629,10 @@
       if FHintWinActive then
         InactivateHint;
-      itemname := Series[j].Title;
-      if Copy(itemname, 1, 7)= 'Ref Low' then exit;
-      if Copy(itemname, 1, 8)= 'Ref High' then exit;
+      if not TitleOK(Series[j].Title) then
+        exit;
       FOnSeries := j;
       FOnValue := ClickedValue;
       textvalue := ValueText(FActiveGraph, Series[j], ClickedValue);
-      dttm := Piece(textvalue, '^', 3);
-      //if copy(textvalue, length(textvalue) - 5, length(textvalue)) = ' 00:00' then
-      //  dttm := Pieces(dttm, ' ', 1, 3);
-      textvalue := Piece(textvalue, '^', 2) + '  ' + dttm +
-        #13 + Piece(textvalue, '^', 4) + '  ' + Piece(textvalue, '^', 5);
+      FormatHint(textvalue);
       Rct := FHintWin.CalcHintRect(Screen.Width, textvalue, nil);
       OffsetRect(Rct, FX, FY + 20);
@@ -6005,13 +6719,17 @@
 end;
 
+procedure TfrmGraphs.InfoMessage(aCaption: string; aColor: TColor; aVisible: boolean);
+begin
+  pnlInfo.Caption := aCaption;
+  pnlInfo.Color := aColor;
+  pnlInfo.Visible := aVisible;
+end;
+
 procedure TfrmGraphs.mnuPopGraphZoomBackClick(Sender: TObject);
 begin
   FFirstClick := true;
-  with lstZoomHistory do
-  begin
-    Items.Delete(Count - 1);
-    if Count = 0 then mnuPopGraphResetClick(self)
-    else ZoomUpdate;
-  end;
+  GtslZoomHistoryFloat.Delete(GtslZoomHistoryFloat.Count - 1);
+  if GtslZoomHistoryFloat.Count = 0 then mnuPopGraphResetClick(self)
+  else ZoomUpdate;
 end;
 
@@ -6021,5 +6739,5 @@
   BigTime, SmallTime: TDateTime;
 begin
-  lastzoom := lstZoomHistory.Items[lstZoomHistory.Count - 1];
+  lastzoom := GtslZoomHistoryFloat[GtslZoomHistoryFloat.Count - 1];
   SmallTime := StrToFloat(Piece(lastzoom, '^', 1));
   BigTime := StrToFloat(Piece(lastzoom, '^', 2));
@@ -6029,10 +6747,11 @@
 
 procedure TfrmGraphs.ZoomUpdateInfo(SmallTime, BigTime: TDateTime);
-begin
-  pnlInfo.Caption := TXT_ZOOMED;
-  pnlInfo.Color := COLOR_ZOOM;
-  pnlInfo.Caption := pnlInfo.Caption + FormatDateTime('mmm d, yyyy  h:nn am/pm', SmallTime);
-  pnlInfo.Caption := pnlInfo.Caption + ' to ' + FormatDateTime('mmm d, yyyy  h:nn am/pm', BigTime) + '.';
-  pnlInfo.Visible := true;
+var
+  aString: string;
+begin
+  aString := TXT_ZOOMED
+           + FormatDateTime('mmm d, yyyy  h:nn am/pm', SmallTime)
+           + ' to ' + FormatDateTime('mmm d, yyyy  h:nn am/pm', BigTime) + '.';
+  InfoMessage(aString, COLOR_ZOOM, true);
   pnlHeader.Visible := true;
 end;
@@ -6061,10 +6780,9 @@
   topflag: boolean;
   i, count: integer;
-  StrForFooter, StrForHeader, aTitle, aWarning, aDateRange: String;
+  StrForFooter, StrForHeader, aTitle, aWarning, aDateRange, aAction: String;
   aHeader: TStringList;
   wrdApp, wrdDoc, wrdPrintDlg: Variant;
   ChildControl: TControl;
 begin
-  topflag := mnuPopGraphStayOnTop.Checked and mnuPopGraphStayOnTop.Enabled;
   try
     wrdApp := CreateOleObject('Word.Application');
@@ -6072,4 +6790,9 @@
     raise Exception.Create('Cannot start MS Word!');
   end;
+  if Sender = mnuPopGraphPrint then
+    aAction := 'PRINT'
+  else
+    aAction := 'COPY';
+  topflag := mnuPopGraphStayOnTop.Checked and mnuPopGraphStayOnTop.Enabled;
   Screen.Cursor := crDefault;
   aTitle := 'CPRS Graphing';
@@ -6100,4 +6823,10 @@
   wrdDoc.PageNumbers.Add;
   wrdDoc := wrdApp.Documents.Item(1);
+  if aAction = 'COPY' then
+  begin
+    wrdDoc.Range.Font.Name := 'Courier New';
+    wrdDoc.Range.Font.Size := 9;
+    wrdDoc.Range.Text := StrForHeader;
+  end;
   wrdDoc.Range.InsertParagraphAfter;
   for i := 0 to scrlTop.ControlCount - 1 do           // goes from top to bottom
@@ -6136,21 +6865,29 @@
     wrdDoc.Paragraphs.Last.Range.Paste;
   end;
-  wrdPrintDlg := wrdApp.Dialogs.item(wdDialogFilePrint);
-  Screen.Cursor := crDefault;
-  Application.ProcessMessages;
-  if topflag then
-    mnuPopGraphStayOnTopClick(self);
-  wrdPrintDlg.Show;
-  wrdApp.Visible := false;
-  Screen.Cursor := crHourGlass;
-  Application.ProcessMessages;
-  Sleep(5000);
-  count := 0;
-  while (wrdApp.Application.BackgroundPrintingStatus > 0) do
-  begin
-    Sleep(1000);
+  if aAction = 'PRINT' then
+  begin
+    wrdPrintDlg := wrdApp.Dialogs.item(wdDialogFilePrint);
+    Screen.Cursor := crDefault;
     Application.ProcessMessages;
-    count := count + 1;
-    if count > 3 then break;
+    if topflag then
+      mnuPopGraphStayOnTopClick(self);
+    wrdPrintDlg.Show;
+    wrdApp.Visible := false;
+    Screen.Cursor := crHourGlass;
+    Application.ProcessMessages;
+    Sleep(5000);
+    count := 0;
+    while (wrdApp.Application.BackgroundPrintingStatus > 0) do
+    begin
+      Sleep(1000);
+      Application.ProcessMessages;
+      count := count + 1;
+      if count > 3 then break;
+    end;
+  end;
+  if aAction = 'COPY' then
+  begin
+    wrdDoc.Range.WholeStory;
+    wrdDoc.Range.Copy;
   end;
   wrdApp.DisplayAlerts := false;
@@ -6161,6 +6898,57 @@
   Application.ProcessMessages;
   if topflag then
-    mnuPopGraphStayOnTopClick(self);
+    if aAction = 'PRINT' then
+      mnuPopGraphStayOnTopClick(self);
   Screen.Cursor := crDefault;
+end;
+
+procedure TfrmGraphs.lstViewsTopChange(Sender: TObject);
+begin
+  Screen.Cursor := crHourGlass;
+  ViewsChange(lvwItemsTop, lstViewsTop, 'top');
+  Screen.Cursor := crDefault;
+end;
+
+procedure TfrmGraphs.lstViewsTopEnter(Sender: TObject);
+begin
+  if Sender = lstViewsTop then
+    lstViewsTop.Tag := 0;                     // reset
+end;
+
+procedure TfrmGraphs.lstViewsTopMouseDown(Sender: TObject; Button: TMouseButton;
+  Shift: TShiftState; X, Y: Integer);
+begin
+  //  for right mouse click make arrangements for view definition ****************
+end;
+
+procedure TfrmGraphs.lstViewsBottomChange(Sender: TObject);
+begin
+  Screen.Cursor := crHourGlass;
+  ViewsChange(lvwItemsBottom, lstViewsBottom, 'bottom');
+  Screen.Cursor := crDefault;
+end;
+
+procedure TfrmGraphs.lstViewsBottomEnter(Sender: TObject);
+begin
+  if Sender = lstViewsBottom then
+    lstViewsBottom.Tag := 0;                     // reset
+end;
+
+procedure TfrmGraphs.lstViewsBottomMouseDown(Sender: TObject;
+  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
+begin
+  //  for right mouse click make arrangements for view definition ****************
+end;
+
+procedure TfrmGraphs.lvwItemsBottomChange(Sender: TObject; Item: TListItem;
+  Change: TItemChange);
+begin
+  if FArrowKeys then
+    if lvwItemsBottom.SelCount > 0 then
+    begin
+      if pnlItemsBottomInfo.Tag <> 1 then
+        lvwItemsBottomClick(self);
+      FArrowKeys := false;
+    end;
 end;
 
@@ -6168,21 +6956,50 @@
   Change: TItemChange);
 begin
-  if FArrowKeys and (lvwItemsTop.SelCount > 0) then
-  begin
-    if pnlItemsTopInfo.Tag <> 1 then
-      lvwItemsTopClick(self);
-    FArrowKeys := false;
-  end;
-end;
-
-procedure TfrmGraphs.lvwItemsBottomChange(Sender: TObject; Item: TListItem;
-  Change: TItemChange);
-begin
-  if FArrowKeys and (lvwItemsBottom.SelCount > 0) then
-  begin
-    if pnlItemsBottomInfo.Tag <> 1 then
-      lvwItemsBottomClick(self);
-    FArrowKeys := false;
-  end;
+  if FArrowKeys then
+    if lvwItemsTop.SelCount > 0 then
+    begin
+      if pnlItemsTopInfo.Tag <> 1 then
+        lvwItemsTopClick(self);
+      FArrowKeys := false;
+    end;
+end;
+
+procedure TfrmGraphs.lvwItemsTopClick(Sender: TObject);
+var
+  i: integer;
+begin
+  FFirstClick := true;
+  if not FFastTrack then
+    if GraphTurboOn then
+      Switch;
+  if lvwItemsTop.SelCount > FGraphSetting.MaxSelect then
+  begin
+    pnlItemsTopInfo.Tag := 1;
+    lvwItemsTop.ClearSelection;
+    if FTooManyItems then FTooManyItems := false
+    else
+    begin
+      ShowMsg('Too many items to graph');
+      FTooManyItems := true;  // flag so that warning will not be displayed twice
+    end;
+    for i := 0 to GtslSelPrevTopFloat.Count - 1 do
+      lvwItemsTop.Items[strtoint(GtslSelPrevTopFloat[i])].Selected := true;
+    pnlItemsTopInfo.Tag := 0;
+  end
+  else
+  begin
+    GtslSelPrevTopFloat.Clear;
+    for i := 0 to lvwItemsTop.Items.Count - 1 do
+    if lvwItemsTop.Items[i].Selected then
+      GtslSelPrevTopFloat.Add(inttostr(i));
+    ItemsClick(Sender, lvwItemsTop, lvwItemsBottom, chkItemsTop, lstViewsTop, GtslSelCopyTop, 'top');
+  end;
+end;
+
+procedure TfrmGraphs.lvwItemsTopEnter(Sender: TObject);
+begin
+  if lvwItemsTop.SelCount = 0 then
+    if lvwItemsTop.Items.Count > 0 then
+      lvwItemsTop.Items[0].Focused := true;
 end;
 
@@ -6192,36 +7009,4 @@
   if Key in [VK_PRIOR, VK_NEXT, VK_UP, VK_DOWN] then
     FArrowKeys := true;
-end;
-
-procedure TfrmGraphs.testcount1Click(Sender: TObject);
-
- function boxcount(aListBox: TListBox): string;
- var
-   i, ccnt: integer;
- begin
-   Result := '';
-   ccnt := 0;
-   for i := 0 to aListBox.Items.Count - 1 do
-     ccnt := ccnt + length(aListBox.Items[i]);
-   Result := inttostr(aListBox.Items.Count) + ';' + inttostr(ccnt);
- end;
-
-var
-  i, lines, total: integer;
-  aString: string;
-begin
-  lines := 0;
-  total := 0;
-  with pnlData do
-  for i:= 0 to pnlData.ControlCount - 1 do
-    if Controls[i] is TListBox then
-    begin
-      aString := boxcount(Controls[i] as TListBox);
-      lines := lines + strtointdef(Piece(aString, ';', 1), 0);
-      total := total + strtointdef(Piece(aString, ';', 2), 0);
-    end;
-  aString := boxcount(lstTypes) + '^' + boxcount(lstItems) + '^' + boxcount(lstData)
-             + '  lines: ' + inttostr(lines) + '   total: ' + inttostr(total);
-  showmessage(aString);
 end;
 
@@ -6238,26 +7023,4 @@
   with FGraphSetting do FixedDateRange := not FixedDateRange;
   ChangeStyle;
-end;
-
-//***************** these are used to fix dropdown when large fonts
-
-procedure TfrmGraphs.cboViewsTopDropDown(Sender: TObject);
-begin
-  cboViewsTop.Align := alNone;
-end;
-
-procedure TfrmGraphs.cboViewsTopDropDownClose(Sender: TObject);
-begin
-  cboViewsTop.Align := alClient;
-end;
-
-procedure TfrmGraphs.cboViewsBottomDropDown(Sender: TObject);
-begin
-  cboViewsBottom.Align := alNone;
-end;
-
-procedure TfrmGraphs.cboViewsBottomDropDownClose(Sender: TObject);
-begin
-  cboViewsBottom.Align := alClient;
 end;
 
@@ -6289,11 +7052,4 @@
 end;
 
-procedure TfrmGraphs.lvwItemsTopEnter(Sender: TObject);
-begin
-  if lvwItemsTop.SelCount = 0 then
-    if lvwItemsTop.Items.Count > 0 then
-      lvwItemsTop.Items[0].Focused := true;
-end;
-
 procedure TfrmGraphs.chkItemsBottomEnter(Sender: TObject);
 begin
@@ -6305,10 +7061,4 @@
 end;
 
-procedure TfrmGraphs.cboViewsBottomEnter(Sender: TObject);
-begin
-  if not chkDualViews.Checked then
-    SelectNext(ActiveControl as TWinControl, True, True);
-end;
-
 procedure TfrmGraphs.lvwItemsBottomEnter(Sender: TObject);
 begin
